<?php
/*
Plugin Name: Hana Flv Player
Plugin URI: http://www.neox.net/w/2008/05/25/hana-flv-player-wordpress-plugin/
Description: The best way to embed Flash Player and Flash movie in your Wordpress Blog. Includes GPL Flowplayer and OS FLV player. Usage: <code>[hana-flv-player video='/source_video.flv' /]</code>
Version: 2.0
Author: HanaDaddy
Author URI: http://www.neox.net
*/

 
class hana_flv_player
{

	

	var $plugin_folder ='hana-flv-player';
	var $version="2.0";
	var $user_attr ;
	var $update_result='';
	
	var $admin_setting_menu='&#8226;Hana Flv Player';
	var $admin_setting_title='Hana Flv Player Default Configuration';
	var $plugin_url;

	//when new player is added , add to below two arrays
	var $player_used= array('1'=> 0,'2'=>0,'3'=>0 ,'4'=>0);
	var $player_base= array('1'=> 'osflv',
				'2'=> 'flowplayer',
				'3'=> 'template_maxi_1.6.0',
				'4'=> 'flowplayer3',
				);
   
	var $default_attr=array(
						//'flowplayer'=>'',
						//'osflvplayer'=>'',
						'player'=>'4',  // 1 : OS FLV , 2: flow player, 3: MAXI, 4: flow player 3
						'width'=>'400',
						'height'=>'330',
						'autoplay'=>'false',
						'loop'=>'false',
						'autorewind'=>'true',
						'autoload'=>'true',
						'clickurl'=>'', 	// just need to be here for div_attr checking
						'video'=>'',		// just need to be here for div_attr checking
						'splashimage'=>'',	// just need to be here for div_attr checking
						
						'more_2'=> '', 		// just need to be here for div_attr checking
						'more_3'=> ''		// just need to be here for div_attr checking
						);
						
	function hana_flv_player() {
		$this->user_attr = get_option('hanaflv_options');
		
		//for newly added attribute , we need this check for the compatibility with old DB entry setting
		//if ( $this->user_attr && !array_key_exists ('splash_image',$this->user_attr))
		//	$this->user_attr['splashimage'] = $default_attr['splashimage'];
		
			
		if (! $this->user_attr) 
			$this->user_attr = $this->default_attr;
		
			
		$this->plugin_url=get_bloginfo("wpurl") . "/wp-content/plugins/$this->plugin_folder";
		
	}

	function bind_hooks() {
		// third arg should be large enough . If executed early in the filter chain, so we do not see <br />
		add_filter('the_content', array(&$this,'hana_flv_return') , 1);
		add_action('admin_menu' , array(&$this,'hana_flv_admin_menu') );

		// init process for button control
		add_action('init', array(&$this,'hana_flv_addbuttons'));
		add_action('admin_print_scripts',array(&$this,'admin_javascript'));
		add_action('admin_footer',array(&$this,'admin_footer'));
	}
	
	function hana_flv_return($content) {
		//return preg_replace_callback('|<hana-flv-player(.*?)></hana-flv-player>|ims', array(&$this,'hana_flv_callback'), $content);
		return preg_replace_callback('|\[hana-flv-player(.*?)/\]|ims', array(&$this,'hana_flv_callback'), $content);
	}
 
	function hana_flv_admin_menu() {
		if ( function_exists('add_options_page') ) {
			add_options_page($this->admin_setting_title,$this->admin_setting_menu, 1, __FILE__,array(&$this,'hana_flv_options_page'));

		}
	}
	
	function hana_flv_callback($arg) {
	
		//print($arg[1]);
		$attr_array=$this->parse_attributes($arg[1]);
	
		
	
		$flv_attr=array();
		$div_attr=array();
		
		$key_list = array_keys($attr_array);
		
		foreach ($key_list as $key ) {
			$flv_attr[$key]=$attr_array[$key];
		}
		//foreach ($key_list as $key ) {
		//	if (array_key_exists($key,$this->user_attr))
		//		$flv_attr[$key]=$attr_array[$key];
		//	else
		//		$div_attr[$key]=$attr_array[$key];
		//}
		
		//print_r($attr_array);
		//print "<hr />";
	    //print_r($flv_attr);
		//print "<hr />";
	    
		reset($flv_attr);
		while(list($key,$value) = each($flv_attr)){
			if ($key != 'video' && $key != 'clickurl' && $key !='splashimage' && $key != 'more_2' && $key != 'more_3' )
				$flv_attr[$key] = strtolower($value);
		}
		
		if (! array_key_exists('player',$flv_attr)){
			$flv_attr['player']=$this->user_attr['player'];
		}
	    if (! array_key_exists('width',$flv_attr)){
			$flv_attr['width']=$this->user_attr['width'];
	    }
		if (! array_key_exists('height',$flv_attr)){
			$flv_attr['height']=$this->user_attr['height'];
	    }
		if (! array_key_exists('autoplay',$flv_attr)){
			$flv_attr['autoplay']=$this->user_attr['autoplay'];
	    }
		if (! array_key_exists('loop',$flv_attr)){
			$flv_attr['loop']=$this->user_attr['loop'];
	    }
	    if (! array_key_exists('autorewind',$flv_attr)){
			$flv_attr['autorewind']=$this->user_attr['autorewind'];
	    }
	    if (! array_key_exists('autoload',$flv_attr)){
			$flv_attr['autoload']=$this->user_attr['autoload'];
	    }

	    //print "<hr />";
	    //print_r($flv_attr);
		
	    if (! array_key_exists('video',$flv_attr)){
			
	    	return '<div style="color:#f00;font-weight:bold;">[hana-flv-player] : "video" attribute is missing for the video file\'s URL.</div>'."\n".'<!-- '. $arg[1] .'-->';	
	    }
	    
	   
	    $div_attr_string = $this->construct_attributes($div_attr);
	 
	    $player=$flv_attr['player'];

	    if ($player == '3' ) {
		// flv player maxi
		
	    		
			$flv_attr['autoplay']=($flv_attr['autoplay']=='true')?'1':'';
			$flv_attr['loop']=($flv_attr['loop']=='true')?'1':'';
			$flv_attr['autoload']=($flv_attr['autoload']=='true')?'1':'';

			//by default the video is autorewind.
			//$flv_attr['autorewind']=($flv_attr['autorewind']=='true')?'on':'off';
			
			$splashImage="";
			if ($flv_attr['splashimage'] != '')
				$splashImage="&amp;startimage=".$flv_attr['splashimage'];

			if ($flv_attr['clickurl'] != '') {
				$onclick="&amp;onclick=".$flv_attr['clickurl'];				
			}
			
			$default_controls="&amp;showstop=1&amp;showvolume=1&amp;showtime=1&amp;showfullscreen=1&amp;srt=1";
			
			if ($flv_attr['more_3'] != "" ){
				
			 //$flv_data['more']=str_replace('&' ,'&amp;',$flv_data['more']);
			    $flv_attr['more_3'] = trim($flv_attr['more_3']);
			    if (substr($flv_attr['more_3'],0,1) != '&' ) 
			 		$flv_attr['more_3'] = '&' . $flv_attr['more_3'];
			}
			
			$output="<hana-ampersand>
<object id='monFlash' type='application/x-shockwave-flash' data='".$this->plugin_url."/".$this->player_base[$player]."/template_maxi/player_flv_maxi.swf' width='".$flv_attr['width']."' height='".$flv_attr['height']."'>
	<param name='movie' value='".$this->plugin_url."/".$this->player_base[$player]."/template_maxi/player_flv_maxi.swf' />
	<param name='allowFullScreen' value='true' />
	<param name='FlashVars' value='flv=".$flv_attr['video']."&amp;width=".$flv_attr['width']."&amp;height=".$flv_attr['height']."&amp;autoplay=".$flv_attr['autoplay']."&amp;autoload=".$flv_attr['autoload'].$splashImage."&amp;loop=".$flv_attr['loop'].$onclick.$default_controls. $flv_attr['more_3'] ."' />
				<p>Unalbe to show flash video</p>
</object></hana-ampersand>";

	    }else 
	    if ($player == '2' ) {
		// flowplayer	
			if ($this->player_used[$player] == 0 )
				$output = "<hana-ampersand><script type='text/javascript' src='".$this->plugin_url."/".$this->player_base[$player]."/examples/js/flashembed.min.js'></script></hana-ampersand>\n";
		
			$this->player_used[$player] += 1;
			$splashImage='';
			 
			$flow_id = 'hana_flv_flow_' . $this->player_used[$player]; 
			if ($flv_attr['clickurl'] == '') {
				$videoFile= "videoFile: '". $flv_attr['video'] ."',";
				$playList="";
			}else{
				$videoFile="";
				$playList= "playList: [ { url: '".$flv_attr['video']."', linkUrl: '".$flv_attr['clickurl']."', linkWindow: '_this' } ]";
			}
			
			// if autoplay == true & splash image exists, the splashimage doesn't show and autoplay doesn't work
			if ($flv_attr['splashimage'] != '' && $flv_attr['autoplay'] == 'false')
				$splashImage = "splashImageFile: '".$flv_attr['splashimage'] ."',";

			//if ($flv_attr['more_2'] != "" && $playList != "" ){

				
		    
			if ($flv_attr['more_2'] != '' ) $flv_attr['more_2'] = ',' . trim($flv_attr['more_2']);
			if ($playList != '' ) $playList = ',' . $playList;
			    
			   // if (substr($flv_attr['more_2'],-1) != ','  ) 
			 	//	$flv_attr['more_2'] = $flv_attr['more_2'] . ',';
			//}
				

			$output .="<hana-ampersand>
			<div $div_attr_string><div id='$flow_id'></div></div>
<script type='text/javascript'>
    flashembed('$flow_id',
      { src:'".$this->plugin_url."/".$this->player_base[$player]."/FlowPlayerDark.swf',  width: ".$flv_attr['width'].",  height: ".$flv_attr['height']." },
      { config: { $videoFile autoPlay: ".$flv_attr['autoplay']." ,loop: ".$flv_attr['loop'].", autoRewind: ".$flv_attr['autorewind'].", autoBuffering: ".$flv_attr['autoload'].",
			$splashImage initialScale: 'scale' " . $flv_attr['more_2'] . "
      		$playList      	                
	    }}
    );
</script></hana-ampersand>";

	    }else
	    if ($player == '4' ) {	
		// flowplayer3
			if ($this->player_used[$player] == 0 )
				$output = "<hana-ampersand><script type='text/javascript' src='".$this->plugin_url."/".$this->player_base[$player]."/example/flowplayer-3.1.1.min.js'></script></hana-ampersand>\n";
		
			$this->player_used[$player] += 1;		
			 
			$flow3_id = 'hana_flv_flow3_' . $this->player_used[$player]; 
			  
			//$output .='<a href="'.$flv_attr['video'].'" style="display:block;width:'.$flv_attr['width'].'px;height:'. $flv_attr['height'].'px" id="$flow3_id"></a>'; 
			$splashImage='';
			if ($flv_attr['splashimage'] != '') { 
				$splashImage='<img src="'.$flv_attr['splashimage']. '" style="width:'.$flv_attr['width'].'px; height:'.$flv_attr['height'].'px;border:0;margin:0;padding:0" />';
			}
			$output.="<hana-ampersand><div $div_attr_string><div id='$flow3_id' style='display:block;width:".$flv_attr['width']."px;height:". $flv_attr['height']."px'>$splashImage</div></div>";
			$player=$this->plugin_url."/".$this->player_base[$player]."/flowplayer-3.1.1.swf";
			$linkurl='';
			if ($flv_attr['clickurl'] != '') {
				$linkurl= ",linkUrl: '".$flv_attr['clickurl']."'";
			}
			
			$loop='';
			$autorewind='';
			
			//if loop is true, ignore autorewind.
			if ($flv_attr['loop'] == 'true' ){
				$loop=', onFinish : function() { this.play(); } ';	
				
			}else			
			if ($flv_attr['autorewind'] =='true'){
				$autorewind=', onFinish : function () { this.seek(0); } ';
			}
			
			//autorewind?
			$output .="
			<script  type='text/javascript'>
		flowplayer('$flow3_id', '$player', { 
    		clip:  { 
    			url: '".$flv_attr['video']."',
        		scaling: 'scale', autoPlay: ".$flv_attr['autoplay'].", autoBuffering: ".$flv_attr['autoload']." 
				$linkurl $loop $autorewind
	        } 
		}); 
			</script></hana-ampersand>
			 ";
			
	    }else  {
		   
	    	if ($this->player_used[$player] == 0 ) 
				$output = "<hana-ampersand><script src='".$this->plugin_url."/".$this->player_base[$player]."/AC_RunActiveContent.js' language='javascript'></script></hana-ampersand>\n";
		
			$this->player_used[$player] += 1;
			
			//In order to autoplay,the autoload must be true
			if ( $flv_attr['autoplay'] == 'true')
				$flv_attr['autoload']='true';
			
			
			$flv_attr['autoplay']=($flv_attr['autoplay']=='true')?'on':'off';
			$flv_attr['loop']=($flv_attr['loop']=='true')?'on':'off';
			$flv_attr['autorewind']=($flv_attr['autorewind']=='true')?'on':'off';
			$flv_attr['autoload']=($flv_attr['autoload']=='true')?'on':'off';
			
			
			
			
	
		
		$output .="<hana-ampersand>
<div $div_attr_string>
<script language='javascript'>
 AC_FL_RunContent('codebase', 'http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0', 'width', '".$flv_attr['width']."', 'height', '".$flv_attr['height']."', 'src',  '".$this->plugin_url."/".$this->player_base[$player]."/' + ((!DetectFlashVer(9, 0, 0) && DetectFlashVer(8, 0, 0)) ? 'player8' : 'player'), 'pluginspage', 'http://www.macromedia.com/go/getflashplayer', 'id', 'flvPlayer', 'allowFullScreen', 'true', 'movie', '".$this->plugin_url."/".$this->player_base[$player]."/' + ((!DetectFlashVer(9, 0, 0) && DetectFlashVer(8, 0, 0)) ? 'player8' : 'player'), 'FlashVars', 'movie=".$flv_attr['video']."&bgcolor=0x051615&fgcolor=0x13ABEC&volume=&autoload=".$flv_attr['autoload']."&autoplay=".$flv_attr['autoplay']."&autorewind=".$flv_attr['autorewind']."&loop=".$flv_attr['loop']."&clickurl=".$flv_attr['clickurl']."&clicktarget=');
</script>
<noscript>
 <object width='".$flv_attr['width']."' height='".$flv_attr['height']."' id='flvPlayer'>
  <param name='allowFullScreen' value='true'>
  <param name='movie' value='".$this->plugin_url."/".$this->player_base[$player]."/player.swf?movie=".$flv_attr['video']."&bgcolor=0x051615&fgcolor=0x13ABEC&volume=&autoload=".$flv_attr['autoload']."&autoplay=".$flv_attr['autoplay']."&autorewind=".$flv_attr['autorewind']."&loop=".$flv_attr['loop']."&clickurl=".$flv_attr['clickurl']."&clicktarget='>
  <embed src='".$this->plugin_url."/".$this->player_base[$player]."/player.swf?movie=/video/babayhana.flv&bgcolor=0x051615&fgcolor=0x13ABEC&volume=&autoload=".$flv_attr['autoload']."&autoplay=".$flv_attr['autoplay']."&autorewind=".$flv_attr['autorewind']."&loop=".$flv_attr['loop']."&clickurl=".$flv_attr['clickurl']."&clicktarget=' width='400' height='300' allowFullScreen='true' type='application/x-shockwave-flash'>
 </object>
</noscript>
</div></hana-ampersand> \n";		

		}
		
    	return  $output;

    }
	

    
	function hana_flv_options_page() {

		//global  $_POST;
		if ( $this->update_result != '' ) 
			print '<div id="message" class="updated fade"><p>' . $this->update_result . '</p></div>';
	?>
<div class="wrap">
	<h2>Configuration for Hana Flv Player V<?php echo $this->version; ?></h2>
	<p>
	Now you can easily embed the FLV Flash videos in your WordPress Blog. 
	I have packaged the three FLV Flash player,<a href='http://www.osflv.com/'>OS FLV</a> (GPL) ,  <a href='http://flowplayer.org/'>FlowPlayer</a> (GPL),
	and <a href='http://flv-player.net/players/maxi/'>FLV Player Maxi</a> (<a href='http://creativecommons.org/licenses/by-sa/3.0/deed.en'>CC</a>, <a href='http://www.mozilla.org/MPL/'>MPL 1.1</a>).
	So you can use them freely without worries even for the commercial purpose unlike the JW player.
    </p>
    <p>
	You can place a specific tag element <code>[hana-flv-player]</code> in the article where you want to show. The 'video' attribute is mandatory. There are other optional attributes. 
	Default values for the options can be defined in this pages. See the <a href="#example">bottom of the page</a> for the example.
    </p>		

 	
	<hr size='1'>
	
	<h3>Default Settings</h3>
	<form action="" method="post">
	<fieldset  class="options">
	<table id="optiontable" class="editform">
		<tr>
			<th valign="top">Default Player:</th>
			<td><select name="hflv_player">
			<option value="1" <?php if ($this->user_attr['player'] == '1' ) print "selected"; ?> >1. OS FLV player (GPL)</option>
			<option value="2" <?php if ($this->user_attr['player'] == '2' ) print "selected"; ?> >2. Flow Player 2 (GPL)</option>
			<option value="3" <?php if ($this->user_attr['player'] == '3' ) print "selected"; ?> >3. FLV Player Maxi (CC, MPL1.1)</option>
			<option value="4" <?php if ($this->user_attr['player'] == '4' ) print "selected"; ?> >4. Flow Player 3 (GPL)</option>
			
			</select>
			<a href='http://www.osflv.com/'>OS FLV V2.0.5</a> , <a href='http://flowplayer.org/'>FlowPlayer V2.2.1 / V3.1.1</a>, <a href='http://flv-player.net/players/maxi/'>FLV Player Maxi</a>
			</td>
		</tr>
		<tr>
			<th valign="top">Default Width</th>
			<td><input type='text' name="hflv_width" value="<?php print $this->user_attr['width'];?>" size='4' maxlength='4'> 
			</td>
		</tr>
		<tr>
			<th valign="top">Default Height</th>
			<td><input type='text' name="hflv_height" value="<?php print $this->user_attr['height'];?>" size='4' maxlength='4'> 
			</td>
		</tr>
		<tr>
			<th valign="top">Default AutoLoad</th>
			<td><select name="hflv_autoload">
			<option value="true" <?php if ( $this->user_attr['autoload'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autoload'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>
		<tr>
			<th valign="top">Default AutoPlay</th>
			<td><select name="hflv_autoplay">
			<option value="true" <?php if ( $this->user_attr['autoplay'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autoplay'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>
		<tr>
			<th valign="top">Default Loop</th>
			<td><select name="hflv_loop">
			<option value="true" <?php if ( $this->user_attr['loop'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['loop'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>
		<tr>
			<th valign="top">Default Auto Rewind</th>
			<td><select name="hflv_autorewind">
			<option value="true" <?php if ( $this->user_attr['autorewind'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autorewind'] == 'false' ) print "selected"; ?> >false</option>
			</select>			
			</td>
		</tr>
	</table>
	<p class="submit"><input name="submit" value="Update Options &raquo;" type="submit"></p>
	</fieldset>
	</form>

<hr size='1'>
<a name="example" ></a>
   <p>
	<h3>Usage Example:</h3>
	<pre style="padding: 10px; border:1px dotted black">
[hana-flv-player 
    video="<?php print $this->plugin_url; ?>/babyhana.flv"
    width="400"
    height="320"
    clickurl="<?php bloginfo("url"); ?>"
    player="4"
    autoplay="false"
    loop="false"
    autorewind="true"
    splashimage="<?php print $this->plugin_url; ?>/splash.jpg"
/]</pre>
<p>When you defined any attribute, please make sure that you use single or double quotes around the attribute value, or my plugin may not recognize the attribute. 
</p>

	Attributes explained:
	<ul>
		<li><strong>video</strong>: URL of the flv video file. This is mandatory.</li>
		<li><strong>width</strong>: Width of the Flash player.</li>
		<li><strong>height</strong>: Height of the Flash player.</li>
		<li><strong>clickurl</strong>: If you want to open a website when a user clicks on the video, you can define the target website URL here. </li>
		<li><strong>player</strong>: If set to "1" , <a href='http://www.osflv.com/'>OS FLV</a> will be used. 
			If set to "2", <a href='http://flowplayer.org/'>FlowPlayer</a> will be used. 
			"3" is for <a href='http://flv-player.net/players/maxi/'>FLV Player Maxi</a>.
			"4" is for <a href='http://flowplayer.org'>FlowPlayer 3(3.1.1)</a>.</li>
		<li><strong>autoload</strong>: If true, the movie will be loaded (downloaded). If false, the starting screen will be blank since no video is downloaded.</li>
		<li><strong>autoplay</strong>: If true, the movie will play automatically when the page is loaded.</li>
		<li><strong>loop</strong>: If Loop is true, the movie will replay itself constantly.</li>
		<li><strong>autorewind</strong>: If AutoRewind is true, the cursor will be reset to the start of the movie when the movie is ended.</li>
		<li><strong>splashimage</strong>: Only works with FlowPlayer and FLV player Maxi. When autoload is off, this splash image will be shown in the player. It only supports JPEG images.</li>
		<li><strong>more_2</strong>: more options for the Flow Player.  
		<li><strong>more_3</strong>: more options for the Flv Player. 
		
	</ul>
<script type="text/javascript">
function hana_flv_player_more_gen(){
    sep="";
	if (document.getElementById("im_player2").checked){
		player=2;
		sep=", ";
	}else
	if (document.getElementById("im_player3").checked){
    	player=3;
    	sep="&";
	}else
		return;

    more="";
 
    if (document.getElementById("im_showstop2").checked){
    	if (player == 3) { more +="showstop=0"; }
    	else 
    	if (player == 2) { more +="showStopButton: false"; }
    }        
	if (document.getElementById("im_showvol2").checked){    
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showvolume=0"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="showVolumeSlider: false, showMuteVolumeButton: false"; 
    	}    		
    }
	if (document.getElementById("im_showtime2").checked){    
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showtime=0"; 
    	}  
    	// for flowplayer time information can be hidden with disabling seekbar	    		
    }
    
    //showplayer=autohide|always|never	
    //controlsOverVideo: ['locked' || 'ease' || 'no']	hideControls: true|false
    
   	if (document.getElementById("im_showctrl1").checked){    
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showplayer=always"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="controlsOverVideo: 'locked'";  // or 'no' ?
    	}
    }else		
    //autohide control
   	if (document.getElementById("im_showctrl2").checked){    
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showplayer=autohide"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="controlsOverVideo: 'ease'"; 
    	}    		
    }else
    //disabling control
    if (document.getElementById("im_showctrl3").checked) {
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showplayer=never"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="hideControls: true"; 
    	}    		    
    }

    pcolor=document.getElementById("im_ctrlcolor_val").value

	if (document.getElementById("im_ctrlcolor_trans").checked) {
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="playeralpha=0&showplayer=autohide"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="controlBarBackgroundColor: -1, controlBarGloss: 'none'"; 
    	}    		    
    }else
    if (pcolor != "" && pcolor.length == 6) {
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="bgcolor1="+pcolor+"&bgcolor2="+pcolor+"&playercolor="+pcolor; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="controlBarBackgroundColor:'0x"+pcolor+"'"; 
    	}    		    
    }

    if (document.getElementById("im_showfull2").checked) {
    	if (player == 3) { 
    		if (more != "") {more +=sep ; } more +="showfullscreen=0"; 
    	} else 
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="showFullScreenButton: false"; 
    	}    		    
    }

    if (document.getElementById("im_showseek2").checked) {
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="showScrubber: false"; 
    	}    		    
    }
    if (document.getElementById("im_showmenu2").checked) {
    	if (player == 2) { 
    		if (more != "") {more +=sep ; } more +="showMenu: false"; 
    	}    		    
    }
    

    obj = document.getElementById("im_predef");
    if (obj.selectedIndex != 0 ){
    	val=obj[obj.selectedIndex].value;
    	
    	//<option value='0'>Do not use Predefined settings</option>
		//<option value='1'>Flow: Simple Black Control Bar</option>			    
		//<option value='2'>Flow: Controls over video</option>			    
		//<option value='3'>Flow: Controls over video with auto-hide</option>			    
		//<option value='4'>Flow: Mimimalistic Look</option>			    
		//<option value='5'>Flv: Showing Custom Logo</option>			    
    	
    	if (val == 1) {
    		player=2;
    		more="showVolumeSlider: false,showMuteVolumeButton: false, showMenu: false, controlBarBackgroundColor: 0";
    	}else
    	if (val == 2) {
    		player=2;
    		more="showVolumeSlider: false, controlsOverVideo: 'locked', controlBarBackgroundColor: -1, controlBarGloss: 'none' ";
    	}else
    	if (val == 3) {
    		player=2;
    		more="showVolumeSlider: false, controlsOverVideo: 'ease',controlBarBackgroundColor: -1, controlBarGloss: 'low' ";
    	}else
    	if (val == 4) {
    		player=2;
    		more="showStopButton: false, showScrubber: false, showVolumeSlider: false,showMuteVolumeButton: false, showFullScreenButton: false, showMenu: false, controlsOverVideo: 'locked',controlBarBackgroundColor: -1,controlBarGloss: 'none', usePlayOverlay: false ";
    	}else
    	if (val == 5) {
    		player=3;
    		more="bgcolor1=396da5&bgcolor2=396da5&playercolor=396da5";
    	}else
    	if (val == 6) {
    		player=3;
    		more="top1=<?php print $this->plugin_url; ?>/logo.png|30|20";
 		}   	
    }
    

    output="[hana-flv-player \n" + 
    	"video=\"<?php print $this->plugin_url; ?>/babyhana.flv\"\n"+   
    	"player=\""+player+"\"\n"+
    	"more_" + player +"=\""+ more + "\"\n" +
   		"/]";
    
    document.getElementById("im_output").value=output;
    //alert(more);
  
     
}
</script>
<hr size='1'>

	<h3>More Attributes (more_2, more_3) Sample Generator</h3>
	By using 'more_2' and 'more_3' attributes, you can use advanced features of the each players. Especially this javascript generator is focused on the interface design option. After selecting the options you want, you can click the 'Generate' button to generate the sample usage in the output textarea.
	<form action="" method="post" onsubmit="hana_flv_player_more_gen(); return false;">
	<fieldset  class="options">
	<table id="optiontable" class="editform">
		<tr>
			<th valign="top">Predefined</th>
			<td>
				<select id='im_predef' name='m_predef'>
				<option value='0'>Do not use Predefined settings</option>
				<option value='1'>Flow2: Simple Black Control Bar</option>			    
				<option value='2'>Flow2: Controls over video</option>			    
				<option value='3'>Flow2: Controls over video with auto-hide</option>			    
				<option value='4'>Flow2: Mimimalistic Look</option>	
				<option value='5'>Flv: Changing border color</option>						    
				<option value='6'>Flv: Showing Custom Logo</option>			    
				</select>
				
			</td>
		</tr>
		<tr>
			<th valign="top">Player</th>
			<td><input type='radio' id='im_player2' value='2' name='m_player' checked /> Flow Player (2) 
			    <input type='radio' id='im_player3' value='3' name='m_player' /> Flv Player Maxi (3) 
			</td>
			    
 		</tr>
		<tr>
			<th valign="top">Show Stop Button</th>
			<td><input type='radio' id='im_showstop1' value='1' name='m_showstop' checked /> Yes 
			    <input type='radio' id='im_showstop2' value='0' name='m_showstop' /> No 
			</td>
			    
 		</tr>
		<tr>
			<th valign="top">Show Volume Control</th>
			<td><input type='radio' id='im_showvol1' value='1' name='m_showvol' checked /> Yes 
			    <input type='radio' id='im_showvol2' value='0' name='m_showvol' /> No 
			</td>
		</tr>
  		<tr>
			<th valign="top">Show Time Info</th>
			<td>Only for Flv Player <input type='radio' id='im_showtime1' value='1' name='m_showtime' checked /> Yes 
			    <input type='radio' id='im_showtime2' value='0' name='m_showtime' /> No  
			</td>
		</tr>
  		<tr>
			<th valign="top">Control Hide or AutoHide</th>
			<td><input type='radio' id='im_showctrl1' value='0' name='m_showctrl' checked /> Show Controls
			    <input type='radio' id='im_showctrl2' value='1' name='m_showctrl' /> AutoHide 
			    <input type='radio' id='im_showctrl3' value='2' name='m_showctrl' /> Hide
			</td>
		</tr>

  		<tr>
			<th valign="top">Control Background Color</th>
			<td>
				<input type='text' id='im_ctrlcolor_val'  name='m_ctrlcolor_val' size='6' maxlength='6'/> 'FFFFFF' format 
				<br />
				<input type='checkbox' id='im_ctrlcolor_trans' value='-1' name='m_ctrlcolor_trans' /> Transparent
			</td>
		</tr>

  		<tr>
			<th valign="top">Show FullScreen Button</th>
			<td><input type='radio' id='im_showfull1' value='1' name='m_showfull' checked  /> Yes 
			    <input type='radio' id='im_showfull2' value='0' name='m_showfull' /> No 
			</td>
		</tr>
  		<tr>
			<th valign="top">Show SeekBar</th>
			<td>Only for Flow Player
			    <input type='radio' id='im_showseek1' value='1' name='m_showseek' checked /> Yes 
			    <input type='radio' id='im_showseek2' value='0' name='m_showseek' /> No 
			</td>
		</tr>
  		<tr>
			<th valign="top">Show Menu Button</th>
			<td>Only for Flow Player
			    <input type='radio' id='im_showmenu1' value='1' name='m_showmenu' checked /> Yes 
			    <input type='radio' id='im_showmenu2' value='0' name='m_showmenu'/> No 
			</td>
		</tr>
		
		
  	</table>
	<p class="submit"><input name="submit" value="Generate &raquo;" type="submit"></p>
	<div><textarea id='im_output' rows='8' cols='70' wrap='soft' ></textarea></div>
	<a href='http://www.flowplayer.org/player/configuration.html'>Flow Player Configuration options link</a>
	<a href='http://flv-player.net/players/maxi/documentation/'>Flv Player Maxi Configuration options link</a>
	</fieldset>
	</form>
    
    <hr size='1'>
    
<h3>Insert flv into template theme files (such as sidebar.php)</h3>
Okay, here is the function that you can use in the theme template files to show FLV movie. Basically you need to 
use <code>hana_flv_player_template_call</code> method. The method takes a single argument.
The argument should be just the string of the attributes of usage explained the above. Just copy below code into your 
theme file and edit red colored attributes accordingly.

<pre style="padding: 10px; border:1px dotted black">
&lt;?php
if (function_exists('hana_flv_player_template_call')){
	$hana_arg="
<span style='color:#ff0000'>video='<?php print $this->plugin_url; ?>/babyhana.flv'
player='2'
width='180'
height='150'
more_2=\"showStopButton: false, showScrubber: false, showVolumeSlider: false,showMuteVolumeButton: false, 
showFullScreenButton: false, showMenu: false, controlsOverVideo: 'locked',controlBarBackgroundColor: -1,
controlBarGloss: 'none', usePlayOverlay:false \"</span>
";
	echo hana_flv_player_template_call($hana_arg);	
}
?&gt;
</pre>
    
    <div><u><strong>Note:</strong> Be careful when you use other website's video file as the video source. Since video files are usually large is size they can use up the bandwidth quickly. 
    So you should ask for the owner's permission before using that link to the file.</u></div>
	</p>
    <p>Thank you for using my plugin. - <a href='http://wwww.neox.net/'>HanaDaddy</a></p>
    <form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="hanadaddy@gmail.com">
<input type="hidden" name="item_name" value="HanaDaddy Donation - Thank you!">
<input type="hidden" name="no_shipping" value="0">
<input type="hidden" name="no_note" value="1">
<input type="hidden" name="currency_code" value="USD">
<input type="hidden" name="tax" value="0">
<input type="hidden" name="lc" value="US">

<input type="hidden" name="bn" value="PP-DonationsBF">
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_SM.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1"><br />


</form>

<script type="text/javascript" src="http://neox.net/plugin_news.php?id=hana-flv-player"></script>
    
</div>

<?php

	}

	function hana_flv_options_update(){
		
		if ( isset($_POST['hflv_player']) ) {
			if ( is_numeric($_POST['hflv_player']) ){
				$this->user_attr['player'] = $_POST['hflv_player'];
			}
		}

		if ( isset($_POST['hflv_width']) ) {
			if ( is_numeric($_POST['hflv_width']) )
				$this->user_attr['width'] = $_POST['hflv_width'];
		}
		
		if ( isset($_POST['hflv_height']) ) {
			if ( is_numeric($_POST['hflv_height']) )
				$this->user_attr['height'] = $_POST['hflv_height'];
		}
		
		if ( isset($_POST['hflv_autoplay']) ) {
			if ($_POST['hflv_autoplay'] =='true' || $_POST['hflv_autoplay'] =='false' )
				$this->user_attr['autoplay'] = $_POST['hflv_autoplay'];
		}
		
		if ( isset($_POST['hflv_loop']) ) {
			if ($_POST['hflv_loop'] =='true' || $_POST['hflv_loop'] =='false' )
				$this->user_attr['loop'] = $_POST['hflv_loop'];
		}

		if ( isset($_POST['hflv_autorewind']) ) {
			if ($_POST['hflv_autorewind'] =='true' || $_POST['hflv_autorewind'] =='false' )
				$this->user_attr['autorewind'] = $_POST['hflv_autorewind'];
		}

		if ( isset($_POST['hflv_autoload']) ) {
			if ($_POST['hflv_autoload'] =='true' || $_POST['hflv_autoload'] =='false' )
				$this->user_attr['autoload'] = $_POST['hflv_autoload'];
		}
		
		//print_r ($this->user_attr);
		
		update_option('hanaflv_options',$this->user_attr);
		//$this->user_attr = get_option('hanaflv_options');
		
		$this->update_result="Settings are updated";
		
	}
    	

    //Support function-----------------------------------------------------

    
    function parse_attributes($attrib_string){

		//first str_replace \n => ' '
		// new line are already stored as <br \> , so need to convert to space
		$search_arr = array("\n","<br />","\t");
	    $replace_arr = array(" "," "," ");	
		$attrib_string = str_replace($search_arr,$replace_arr,$attrib_string);
	
		//print ($attrib_string);	
		
	    $regex='@([^\s=]+)\s*=\s*(\'[^<\']*\'|"[^<"]*"|\S*)@';
		
	    preg_match_all($regex, $attrib_string, $matches);
	
		$attr=array();
	
		//print_r($matches);
		for ($i=0; $i< count($matches[0]); $i++) {
	  		if ( ! empty($matches[0][$i]) && ! empty($matches[1][$i]))  {
				
	  			
	  			if (preg_match("/^'(.*)'$/",$matches[2][$i],$vmatch)) {
					$value=$vmatch[1];	
				}else 
				if (preg_match('/^"(.*)"$/',$matches[2][$i],$vmatch)) {
					$value=$vmatch[1];	
				}else{
					$value=$matches[2][$i];
				}
				$key=strtolower($matches[1][$i]);
				$attr[$key]= $value ;
				
			}
		}
	   
		//print "<pre>";
		//print_r($attr);
		//print "</pre>"; 
		return $attr;
		
	}
	
	function construct_attributes($arr){
	
		$output="";
		
		reset($arr);
		while (list($key, $value) = each ($arr)) {
			$envelop_char='"';
			
			if (strstr($value,'"') !== false) {
				
				$envelop_char='\'';			
			}
			$output .= " $key=".$envelop_char.$value.$envelop_char;
		}
		
		return $output;
	}
	
    	
	function hana_flv_addbuttons() {
	   	// Don't bother doing this stuff if the current user lacks permissions
	   	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
	    	return;
	    //rich_editing
	    add_filter("mce_external_plugins", array(&$this,'add_tinymce_plugin'));
	    add_filter('mce_buttons', array(&$this,'register_button'));
	     
	    //for html editing 
	    add_action('edit_form_advanced', array(&$this,'print_javascript'));
		add_action('edit_page_form',array(&$this,'print_javascript'));
	    //add_action('admin_footer','print_javascript');
	}
	 
	function register_button($buttons) {
	   	array_push($buttons,  "hfplayer");
	   	return $buttons;
	}
	 
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function add_tinymce_plugin($plugin_array) {
	   	$plugin_array['hanaflvplayer'] = $this->plugin_url . '/tinymce3/editor_plugin.js';
	   	return $plugin_array;
	}

	function admin_javascript(){
		//show only when editing a post or page.
		if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
		
			//wp_enqueue_script only works  in => 'init'(for all), 'template_redirect'(for only public) , 'admin_print_scripts' for admin only
			if (function_exists('wp_enqueue_script')) {
				$jspath='/'. PLUGINDIR  . '/'. $this->plugin_folder.'/jqModal/jqModal.js';
				wp_enqueue_script('jqmodal_hana', $jspath, array('jquery'));
			}

		}
		
	}
	function print_javascript () {
	 
?>
   <!--  for popup dialog -->
   <link href="<?php echo $this->plugin_url . '/jqModal/jqModal.css'; ?>" type="text/css" rel="stylesheet" />

   <script type="text/javascript">
   	jQuery(document).ready(function(){
		// Add the buttons to the HTML view
		jQuery("#ed_toolbar").append('<input type=\"button\" class=\"ed_button\" onclick=\"jQuery(\'#dialog_hanaflv\').jqmShow();\" title=\"Hana Flv Player\" value=\"Hana Flv\" />');
   	});

	jQuery(document).ready(function () {
		jQuery('#dialog_hanaflv').jqm();
	});

	function update_hanaflvplayer(){
		var f=document.hanaflvoptions;
		if (f== null) return;
		

	    /*[hana-flv-player 
		    video="http://localhost/wp271/wp-content/plugins/hana-flv-player/babyhana.flv"
		    width="400"
		    height="320"
		    clickurl="http://localhost/wp271"
		    player="4"
		    autoplay="false"
		    loop="false"
		    autorewind="true"
		    splashimage="http://localhost/wp271/wp-content/plugins/hana-flv-player/splash.jpg"
		/]*/

		text='[hana-flv-player video="'+f.video.value+'"\n';

		if (f.width.value.length >0 )
			text +='    width="'+f.width.value+'" \n';
		if (f.height.value.length > 0 )
			text +='    height="'+f.height.value+'" \n';

		text +='    player="'+f.player[f.player.selectedIndex].value+'" \n';
		text +='    autoload="'+f.autoload[f.autoload.selectedIndex].value+'" autoplay="'+f.autoplay[f.autoplay.selectedIndex].value+'" \n';
		text +='    loop="'+f.loop[f.loop.selectedIndex].value+'" autorewind="'+f.autorewind[f.autorewind.selectedIndex].value+'" \n';
		if (f.clickurl.value.length > 0 )
			text +='    clickurl="'+f.clickurl.value +'" \n';

		if (f.splashimage.value.length > 0)		
			text +='    splashimage="'+f.splashimage.value+'" \n';
			
		text += ' /]';
		
		if (text.length > 0){
			if ( typeof tinyMCE != 'undefined' && ( ed = tinyMCE.activeEditor ) && !ed.isHidden() ) {
				ed.focus();
				if (tinymce.isIE)
					ed.selection.moveToBookmark(tinymce.EditorManager.activeEditor.windowManager.bookmark);

				ed.execCommand('mceInsertContent', false, text);
			} else
				edInsertContent(edCanvas, text);
			 
		}	
		 
		
		jQuery('#dialog_hanaflv').jqmHide();
	}

	
   	</script>

	
	
	<?php   
	  //end of print_javascript 
	}

	function admin_footer(){
		
		if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
		
		?>
		<div id="dialog_hanaflv" class='jqmWindow' >
	<div style='width:100%;text-align:center'>
	<h3><a href='http://www.neox.net/w/2008/05/25/hana-flv-player-wordpress-plugin/' target='_new'>Hana Flv Player</a></h3>
	 

	<form name='hanaflvoptions' onsubmit='return false;' >
	
	<table style='text-align:left;width:100%;'>
		<tr> 
			<td valign='top'>Video(required)</td>
			<td><input type='text' size='50' name='video' /></td>
		</tr>	
		<tr>
			<td valign="top">Flash Player:</td>
			<td><select name="player">
			<option value="1" <?php if ($this->user_attr['player'] == '1' ) print "selected"; ?> >1. OS FLV player (GPL)</option>
			<option value="2" <?php if ($this->user_attr['player'] == '2' ) print "selected"; ?> >2. Flow Player 2 (GPL)</option>
			<option value="3" <?php if ($this->user_attr['player'] == '3' ) print "selected"; ?> >3. FLV Player Maxi (CC, MPL1.1)</option>
			<option value="4" <?php if ($this->user_attr['player'] == '4' ) print "selected"; ?> >4. Flow Player 3 (GPL)</option>
			
			</select>
			</td>
		</tr>
		<tr>
			<td valign="top">Width</td>
			<td><input type='text' name="width" value="<?php print $this->user_attr['width'];?>" size='4' maxlength='4' /> 
			</td>
		</tr>
		<tr>
			<td valign="top">Height</td>
			<td><input type='text' name="height" value="<?php print $this->user_attr['height'];?>" size='4' maxlength='4' /> 
			</td>
		</tr>
		<tr>
			<td valign="top">AutoLoad</td>
			<td><select name="autoload">
			<option value="true" <?php if ( $this->user_attr['autoload'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autoload'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>		
		
		<tr>
			<td valign="top">AutoPlay</td>
			<td><select name="autoplay">
			<option value="true" <?php if ( $this->user_attr['autoplay'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autoplay'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>
		<tr>
			<td valign="top">Play Loop</td>
			<td><select name="loop">
			<option value="true" <?php if ( $this->user_attr['loop'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['loop'] == 'false' ) print "selected"; ?> >false</option>
			</select>
			</td>
		</tr>
		<tr>
			<td valign="top">Auto Rewind</td>
			<td><select name="autorewind">
			<option value="true" <?php if ( $this->user_attr['autorewind'] == 'true' ) print "selected"; ?> >true</option>
			<option value="false" <?php if ( $this->user_attr['autorewind'] == 'false' ) print "selected"; ?> >false</option>
			</select>			
			</td>
		</tr>
		<tr>
			<td valign="top">Click URL</td>
			<td><input type='text' name='clickurl' size='50' />			
			</td>
		</tr>
		<tr>
			<td valign="top">Splash Image URL</td>
			<td><input type='text' name='splashimage' size='50'/>			
			</td>
		</tr>
	</table>

	 	<p class='submit'><input type='button' value='OK' onclick='update_hanaflvplayer()'; >
	 	<input type='button' value='Cancel' onclick="jQuery('#dialog_hanaflv').jqmHide();" >
	 	</p>
	</div>	
	
	</form>	 
			
	 
	
	</div>
	  <?php 
		}
	}
	
}


//this is to return back the ampersand .
if (!class_exists('hana_ampersand')){

class hana_ampersand 


{
	var $target = array("&#8217;","&#8220;","&#8221;","&#038;","\'","&#8242;", "&#8216;");
	var $replace= array("'",'"','"',"&","'","'","'");
	

	function hana_return_ampersand (){
		
	}

	function bind_hooks(){
		// must be executed at the end to guarantee that it is not modified by other plugin	
		add_filter('the_content', array(&$this,'filter_callback'), '100');
	}
	

	function filter_callback($content) {
		return preg_replace_callback('|<hana-ampersand>(.*?)</hana-ampersand>|ims', array(&$this,'replace_callback'), $content);
	}
		
	function replace_callback($arg) {
		return str_replace($this->target,$this->replace,clean_pre($arg[1]));
	}
}

}

$hana_flv = new hana_flv_player();

$hana_flv->bind_hooks();


// admin option page update
if ( isset($_POST['hflv_player']) ) {
	$hana_flv->hana_flv_options_update();
}


// Below is to convert &#038 back to '&'
$hana_amp = new hana_ampersand();
$hana_amp->bind_hooks();

function hana_flv_player_template_call($arg){
	global $hana_flv;
	
	if(!$hana_flv){
		$hana_flv = new hana_flv_player();
	}
	
	return $hana_flv->hana_flv_callback(array('',$arg));
}

